=== debian/changelog ===
ncbi-vdb (2.10.7+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Remove trailing whitespace in debian/changelog (routine-update)
  * debian/not-installed: Update for new release (more test-related files).

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 02 Jun 2020 21:35:11 -0400

ncbi-vdb (2.10.6+dfsg-5) unstable; urgency=medium

  * Comment out fix_parallel_build.patch (evidently insufficient) in favor
    of overriding dh_prep to spare(!) debian/tmp.
  * optionally_reinstate_default_schema.patch: Use plain extern rather
    than SRA_EXTERN to avoid likely multiple definitions under GCC 10.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 26 May 2020 10:32:22 -0400

ncbi-vdb (2.10.6+dfsg-4) unstable; urgency=medium

  * debian/patches/fix_parallel_build.patch (new): Use unique temporary
    directory names when combining static libraries.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 26 May 2020 08:06:35 -0400

ncbi-vdb (2.10.6+dfsg-3) unstable; urgency=medium

  * debian/patches/optionally_reinstate_default_schema.patch: New patch to
    let callers use the default schema, otherwise dropped upstream as of
    2.10.0.  (The toggle is a new global variable
    SRAUseLegacyDefaultSchema, which sra-sdk's tools/sra-load will enable
    to address the autopkgtest failure #961347.)

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 25 May 2020 22:38:23 -0400

ncbi-vdb (2.10.6+dfsg-2) unstable; urgency=medium

  * Install libs/vfs/services-priv.h as .../services-priv-internal.h to
    distinguish it from interfaces/vfs/services-priv.h.  (Neither can
    stand in for the other.)
  * Formally refresh patches that developed offsets.
  * Factor out a new DSLMFLAGS macro for common d-shlibmove flags; include
    the libmbedx509-0 quirk there since it will soon be needed everywhere.
  * Address remaining underlinkage of system libraries (mbed*, z, bz2).
    At this point, the only remaining unresolved references are of libkdf5
    against symbols that could come from either libncbi-vdb or libncbi-wvdb.
    (Closes: #952623, #952627, #953897.)
  * Copy headers rather than moving them to allow for consecutive builds.
  * Fix typo in override_dh_missing name; supply debian/not-installed.
  * Add myself to Uploaders.

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 20 May 2020 22:13:24 -0400

ncbi-vdb (2.10.6+dfsg-1) unstable; urgency=medium

  * Team upload.

  * New upstream version
  * Rules-Requires-Root: no (routine-update)

 -- Steffen Moeller <moeller@debian.org>  Mon, 18 May 2020 23:55:32 +0200

ncbi-vdb (2.10.5+dfsg-1) UNRELEASED; urgency=medium

  * New upstream version

  [ Andreas TIlle ]
  * Try even harder to get rid of vdb_mbedtls symbols

  [ Michael R. Crusoe ]
  * Update mbedtls patches to 2.10.5 and consolidate them

 -- Steffen Moeller <moeller@debian.org>  Mon, 02 Mar 2020 02:04:31 +0100

ncbi-vdb (2.10.3+dfsg-2) unstable; urgency=medium

  * Removed additional invocations of vdb_mbedtls to avoid
    undefined references when linking against vdb.

 -- Steffen Moeller <moeller@debian.org>  Mon, 02 Mar 2020 01:12:48 +0100
